Bug 1163892 - [PATCH] Secure mode in Hadoop cluster
Summary: [PATCH] Secure mode in Hadoop cluster
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: hadoop
Version: 21
Hardware: All
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Robert Rati
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2014-11-13 16:12 UTC by František Dvořák
Modified: 2015-12-02 16:31 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-12-02 04:58:01 UTC
Type: Bug


Attachments (Terms of Use)
Launch datanode under root user, add necessary environment. (2.11 KB, patch)
2014-11-13 16:12 UTC, František Dvořák
no flags Details | Diff
Change owner of container-executor to nodemanager daemon group. (740 bytes, patch)
2014-11-13 16:13 UTC, František Dvořák
no flags Details | Diff

Description František Dvořák 2014-11-13 16:12:29 UTC
Created attachment 957214 [details]
Launch datanode under root user, add necessary environment.

Description of problem:

For secure mode to be enabled in Hadoop cluster, there are needed some (rather small?) changes in packaging:

1) /usr/bin/container-executor must be owned by group used for starting the nodemanager daemon (it could be 'yarn', but upstream documentation mentions 'hadoop')

2) datanode must be launched under root (it will use jsvc and drop privileges). There are needed also some environment variables.


Version-Release number of selected component (if applicable):

2.4.1-6.fc21


How reproducible:

Enabling security is described here: http://hadoop.apache.org/docs/stable/hadoop-project-dist/hadoop-common/SecureMode.html

I used these properties in /etc/hadoop/*-site.xml files:

  hadoop.security.authentication => kerberos
  hadoop.security.auth_to_local
    RULE:[2:$1;$2@$0](^jhs;.*@REALM$)s/^.*$/mapred/
    RULE:[2:$1;$2@$0](^[nd]n;.*@REALM$)s/^.*$/hdfs/
    DEFAULT
  dfs.block.access.token.enable => true
  yarn.nodemanager.container-executor.class => org.apache.hadoop.yarn.server.nodemanager.LinuxContainerExecutor
  yarn.nodemanager.linux-container-executor.group => hadoop
  ...

And edited /etc/hadoop/container-executor.cfg file.


Actual results:

Hadoop datanode daemon rejects to activate secure mode (logged in /var/log/hadoop-*/*.log).

Hadoop nodemanager won't launch with the container. There is also other way, how to check this:
  runuser yarn -s /bin/bash /bin/bash -c 'container-executor --checksetup'


Expected results:

  No changes needed in unit files and owerships to activate secure mode.


Additional info:

Patches for hadoop package attached. It works in both modes - without security and with security enabled.

Packages with the patches built also in COPR:
http://copr-fe.cloud.fedoraproject.org/coprs/valtri/hadoop/

Comment 1 František Dvořák 2014-11-13 16:13:38 UTC
Created attachment 957216 [details]
Change owner of container-executor to nodemanager daemon group.

Comment 2 Fedora End Of Life 2015-11-04 14:53:47 UTC
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 3 Fedora End Of Life 2015-12-02 04:58:04 UTC
Fedora 21 changed to end-of-life (EOL) status on 2015-12-01. Fedora 21 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.